const Discord = require('discord.js');
const inventory = require('../Schema/inventory');
const items = require('./shopitem');

module.exports = {
    name: 'buy',
    async run(client, message, args) {
        if (!args[0]) return message.reply("Please specify an item to buy");
        const itemToBuy = args[0].toLowerCase()

        const validItem = !!items.find(
          (val) => val.item.toLowerCase() === itemToBuy
          );

        if(!validItem) return message.reply('The item you are trying to buy is not valid')

        const itemPrice = items.find((val) => val.item.toLowerCase() === itemToBuy).price;

        const userBalance = await client.bal(message.author.id);
        if(userBalance < itemPrice) return message.reply(`You only have ${userBalance} coins, the price of this item is ${itemPrice} coins`);

        const params = {
          User: message.author.id,
        };
        inventory.findOne(params, async (err, data) => {
          if (data){
            const hasItem = Object.keys(data.Inventory).includes(itemToBuy);
            if(!hasItem) {
              data.Inventory[itemToBuy] = 1;
            } else {
              data.Inventory[itemToBuy]++;
            }
            await inventory.findOneAndUpdate(params, data);
          } else {
            new inventory({
              User: message.author.id,
              Inventory: {
                [itemToBuy]: 1,
              },
            }).save()
          }
          message.reply(`You have bought ${itemToBuy}`)
          client.remove(message.author.id, itemPrice)
        })
    }
};