function ukori(token, prefix, stat, status, statusType, mongoPath) {
  const Discord = require('discord.js');
  const Levels = require('discord-xp')
  const client = new Discord.Client();
  const express = require('express')
  const { readdirSync, read } = require('fs');
  const ms = require('ms');
  const { join } = require('path');
  const mongoose = require('mongoose')

  mongoose.connect(mongoPath, {
    useUnifiedTopology: true,
    useNewUrlParser: true,
    useFindAndModify: false 
    }).then(console.log('Connected to mongo!'))

  client.commands = new Discord.Collection();
  const Timeout = new Discord.Collection();

  const commandFiles = readdirSync(join(__dirname,  "commands")).filter(file => file.endsWith(".js"));

  for (const file of commandFiles) {
      const  command = require(join(__dirname, "commands",  `${file}`));
      client.commands.set(command.name, command);
  }

  Levels.setURL(mongoPath)

  client.on("error", console.error);
  

  //---------

  client.on('ready', () => {
    console.log(`Logging in as ${client.user.tag}!`);

    client.user.setStatus(`${stat}`)
    const arrayOfStatus = status;

    let index = 0;
    setInterval(() => {
      if(index === arrayOfStatus.length) index = 0;
      const status = arrayOfStatus[index];
      client.user.setActivity(status, { type: `${statusType}` }).catch(console.error)
      index++;
    }, 5000)
})
  //------------

  

  client.on("message", async message => {

      if(message.author.bot) return;
      if(message.channel.type === 'dm') return message.reply("Commands don't work in dms");

      const randomAmountOfXp = Math.floor(Math.random() * 29) + 1; // Min 1, Max 30
      const hasLeveledUp = await Levels.appendXp(message.author.id, message.guild.id, randomAmountOfXp);
      if (hasLeveledUp) {
        const user = await Levels.fetch(message.author.id, message.guild.id);
        message.channel.send(`${message.author}, congratulations! You have leveled up to **${user.level}**!`);
      }


      if (message.content.startsWith(prefix)) {
        const args = message.content.slice(prefix.length).trim().split(/ +/);

        const commandName = args.shift().toLowerCase();

        const command = client.commands.get(commandName) || client.commands.find(cmd => cmd.aliases && cmd.aliases.includes(commandName));
        if (!command) return;

        if (command) {
            if (command.cooldown) {
                if (Timeout.has(`${command.name}${message.author.id}`)) return message.channel.send(`Please Wait \`${ms(Timeout.get(`${command.name}${message.author.id}`) - Date.now(), { long: true })}\` Before using this command again!`);
                command.run(client, message, args)
                Timeout.set(`${command.name}${message.author.id}`, Date.now() + command.cooldown)
                setTimeout(() => {
                    Timeout.delete(`${command.name}${message.author.id}`)
                }, command.cooldown)
            } else command.run(client, message, args);
        }
    }
  })

  //-------------

  const WelcomeSchema = require('./Schema/welcome-schema');

  client.on("guildMemberAdd", async (member, guild) => {
      WelcomeSchema.findOne({ guildId: member.guild.id }, async (err, data) => {
          if(!data) return;

          const user = member.user;
          const channel = member.guild.channels.cache.get(data.channelId);
          const welcomemsg = data.welcomeMsg

          channel.send(`Welcome ${user}, ` + welcomemsg)
      })
  })


  const coinSchema = require('./Schema/coins');

  client.bal = (userId) => new Promise(async ful => {
    const data = await coinSchema.findOne({ userId });
    if(!data) return ful(0);
    ful(data.coins)
  })

  client.add = (userId, coins) => {
    coinSchema.findOne({ userId }, async (err, data) => {
      if(err) throw err;
      if(data) {
        data.coins += coins;
      } else {
        data = new coinSchema({
          userId,
          coins
        })
      }
      data.save()
    })
  }

  client.remove = (userId, coins) => {
    coinSchema.findOne({ userId }, async (err, data) => {
      if(err) throw err;
      if(data) {
        data.coins -= coins;
      } else {
        data = new coinSchema({
          userId,
          coins: -coins
        })
      }
    data.save()
    })
  }

  //--------------

  /*bot.on("guildMemberAdd", async (member) => {
    console.log(member.user.tag); 
  })*/

  client.login(token);

  const app = express();
  const port = 3030

  app.get('/', (req, res) => {
      res.send('<script>window.close();</script>');
      if (req.query.col && req.query.row) {
          minesweeper.makeMove(parseInt(req.query.col),   parseInt(req.query.row));
      }
  });

  app.listen(port, () => {
      console.log('Connected to server');
  });
};

module.exports = { ukori }